SystemOrganization addCategory: #'Glamour-Core'!

Announcer subclass: #GLMPane
	instanceVariableNames: 'browser name presentations ports'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPane classSide methodsFor: 'private' stamp: ' 25/2/09 23:38'!
portClass 
	 
	^GLMPanePort! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addPresentation: aPresentation 
	 
	self 
		notingPresentationChangeDo: 
			[self presentations 
				addLast: 
					(aPresentation 
						pane: self; 
						yourself)]! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addPresentations: aCollection 
	 
	self 
		notingPresentationChangeDo: 
			[aCollection 
				do: 
					[:each |  
					self presentations 
						addLast: 
							(each 
								pane: self; 
								yourself)]]! !

!GLMPane methodsFor: 'converting' stamp: ' 25/2/09 23:38'!
asGlamorousPane 
	 
	^self! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
browser 
	 
	^browser! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
browser: aBrowser 
	 
	browser := aBrowser! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
clear 
	 
	self notingPresentationChangeDo: [presentations := nil]. 
	self ports do: [:each | each value: nil]! !

!GLMPane methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
hasBrowser 
	 
	^self browser isNil not! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
matchingPresentations 
	 
	^self presentations select: [:each | each matches]! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
name 
	 
	^name! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
name: aSymbol 
	 
	name := aSymbol! !

!GLMPane methodsFor: 'private' stamp: ' 25/2/09 23:38'!
notingPresentationChangeDo: aBlock 
	 
	| oldPresentations oldMatchingPresentations | 
	oldPresentations := self presentations copy. 
	oldMatchingPresentations := self matchingPresentations. 
	aBlock value. 
	self presentations ~= oldPresentations 
		ifTrue: 
			[self 
				announce: 
					((GLMPresentationsChanged new) 
						pane: self; 
						oldPresentations: oldPresentations; 
						yourself)]. 
	self matchingPresentations ~= oldMatchingPresentations 
		ifTrue: 
			[self 
				announce: 
					((GLMMatchingPresentationsChanged new) 
						pane: self; 
						oldMatchingPresentations: oldMatchingPresentations; 
						yourself)]! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
port: aSymbol 
	 
	^self ports 
		detect: [:each | each name = aSymbol] 
		ifNone: 
			[self ports 
				addLast: 
					((self class portClass new) 
						pane: self; 
						name: aSymbol; 
						yourself)]! !

!GLMPane methodsFor: 'private' stamp: ' 25/2/09 23:38'!
portEvent: aPortEvent 
	 
	self hasBrowser ifTrue: [self browser innerPortEvent: aPortEvent]. 
	self presentations do: [:each | each outerPortEvent: aPortEvent]! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
ports 
	 
	^ports ifNil: [ports := OrderedCollection new]! !

!GLMPane methodsFor: 'private' stamp: ' 25/2/09 23:38'!
postCopy 
	 
	super postCopy! !

!GLMPane methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
presentations 
	 
	^presentations ifNil: [presentations := OrderedCollection new]! !

!GLMPane methodsFor: 'rendering' stamp: ' 25/2/09 23:38'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderPane: self! !

!GLMPane methodsFor: 'announcements' stamp: ' 25/2/09 23:38'!
whenMatchingPresentationsChanged: aBlock 
	 
	^self when: GLMMatchingPresentationsChanged do: aBlock! !

!GLMPane methodsFor: 'announcements' stamp: ' 25/2/09 23:38'!
whenPresentationsChanged: aBlock 
	 
	^self when: GLMPresentationsChanged do: aBlock! !

Announcer subclass: #GLMPresentation
	instanceVariableNames: 'pane title transformation actions condition isInspectable implicitNotNil'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMPresentation subclass: #GLMBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBrowser commentStamp: '<historical>' prior: 0!
Browsers are one of the core components in Glamour.

They contain panes and transmission between them, which can either be explicitely defined by the user (such as in the TableLayoutBrowser) or implicitely defined (such as in the Finder).

Browsers serve as composition managers. They determine when and under which conditions transmissions should be triggered and how they connect the ports of panes. In return, panes inform the browsers when event occur on their ports so that the browser can make an informed decission on what to do.!

!GLMBrowser methodsFor: 'scripting-private' stamp: ' 25/2/09 23:39'!
initializeScriptingDefaults 
	"Initialize some default behavior if the user did not explcitely script it. 
 
	Subclasses can use this to create a default startup transmission or show 
	a default pane or something like that." 
	 
	^self! !

!GLMBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
panes 
	"Return an (ordered) collection of the panes used by this browser." 
	 
	self subclassResponsibility! !

GLMBrowser subclass: #GLMExplicitBrowser
	instanceVariableNames: 'panes hiddenPane transmissions jumpstartTransmissions pushedPorts pulledPorts scriptTransmission'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addJumpstart: aTransmission 
	 
	self jumpstartTransmissions addLast: aTransmission! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addPane: aPane 
	 
	aPane browser: self. 
	self panes addLast: aPane! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addPull: aSymbol to: aContainedPort 
	"Asks the browser to push changes of aContainedPort to the outer pane's port identified by aSymbol." 
	 
	self pulledPorts 
		add: 
			((GLMPublishedPort new) 
				innerPort: aContainedPort; 
				outerPortName: aSymbol; 
				yourself)! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addPush: aContainedPort as: aSymbol 
	"Asks the browser to push changes of aContainedPort to the outer pane's port identified by aSymbol." 
	 
	self pushedPorts 
		add: 
			((GLMPublishedPort new) 
				innerPort: aContainedPort; 
				outerPortName: aSymbol; 
				yourself)! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addTransmission: aTransmission 
	 
	self transmissions addLast: aTransmission! !

!GLMExplicitBrowser methodsFor: 'events' stamp: ' 25/2/09 23:38'!
innerPortEvent: aPortEvent 
	 
	(self pushedPorts select: [:each | each innerPort = aPortEvent port]) 
		do: 
			[:each | (self pane port: each outerPortName) value: aPortEvent value]. 
	aPortEvent hasChanged 
		ifTrue: 
			[(self transmissions select: [:each | each originatesAt: aPortEvent port]) 
				do: [:each | each transmit]]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
jumpstartTransmissions 
	 
	^jumpstartTransmissions 
		ifNil: [jumpstartTransmissions := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'events' stamp: ' 25/2/09 23:38'!
outerPortEvent: aPortEvent 
	 
	super outerPortEvent: aPortEvent.	"Hack for a jumpstart transmission (we should clean this up)." 
	aPortEvent portName = #entity 
		ifTrue: 
			[self jumpstartTransmissions 
				do: 
					[:each |  
					each 
						clearOrigins; 
						addActiveOrigin: (self pane port: #entity); 
						transmit]]. 
	aPortEvent hasChanged 
		ifTrue: 
			[(self transmissions select: [:each | each originatesAt: aPortEvent port]) 
				do: [:each | each transmit]]. 
	(self pulledPorts 
		select: [:each | each outerPortName = aPortEvent portName]) 
		do: [:each | each innerPort receive: aPortEvent transmission]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
paneNamed: aSymbol 
	 
	^self panes detect: [:each | each name = aSymbol]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
panes 
	 
	^panes ifNil: [panes := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pulledPorts 
	 
	^pulledPorts ifNil: [pulledPorts := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pushedPorts 
	 
	^pushedPorts ifNil: [pushedPorts := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'scripting-private' stamp: ' 25/2/09 23:39'!
resolveDestinationPort: aPortReference 
	 
	^self resolvePort: aPortReference defaultPortName: #entity! !

!GLMExplicitBrowser methodsFor: 'scripting-private' stamp: ' 25/2/09 23:39'!
resolveOriginPort: aPortReference 
	 
	^self resolvePort: aPortReference defaultPortName: #selection! !

!GLMExplicitBrowser methodsFor: 'scripting-private' stamp: ' 25/2/09 23:39'!
resolvePort: aPortReference defaultPortName: aSymbol 
	 
	| tmp | 
	tmp := aPortReference. 
	(tmp isKindOf: GLMPane) ifTrue: [tmp := tmp port: aSymbol]. 
	(tmp isKindOf: GLMPort) ifTrue: [^tmp]. 
	tmp isSymbol ifTrue: [tmp := tmp -> aSymbol]. 
	(tmp isKindOf: Association) 
		ifTrue: 
			[^tmp key = #outer 
				ifTrue: 
					[(GLMParentPort new) 
						presentation: self; 
						name: tmp value; 
						yourself] 
				ifFalse: [(self paneNamed: tmp key) port: tmp value]]. 
	self error: 'Unknown port reference.'! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
transmissions 
	 
	^transmissions ifNil: [transmissions := OrderedCollection new]! !

GLMBrowser subclass: #GLMImplicitBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
actions 
	 
	^actions ifNil: [actions := OrderedCollection new]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addAction: anAction 
	 
	self actions addLast: anAction! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
beInspectable 
	 
	^isInspectable := true! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
condition 
	 
	^condition ifNil: [condition := [true]]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
condition: anObject 
	 
	condition := anObject! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
displayValue 
	 
	^self transformation glamourValue: self entity! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 25/2/09 23:38'!
entity 
	 
	^(self pane port: #entity) value! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 25/2/09 23:38'!
entity: anObject 
	 
	(self pane port: #entity) value: anObject! !

!GLMPresentation methodsFor: 'events' stamp: ' 25/2/09 23:38'!
innerPortEvent: aPortEvent 
	 
	! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
isInspectable 
	 
	^isInspectable ifNil: [isInspectable := false]! !

!GLMPresentation methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
matches 
	 
	^(self usesImplicitNotNil 
		ifTrue: [GLMNotNilCondition new glamourValue: self entity] 
		ifFalse: [true]) and: [(self condition glamourValue: self entity) = true]! !

!GLMPresentation methodsFor: 'events' stamp: ' 25/2/09 23:38'!
outerPortEvent: aPortEvent 
	 
	self 
		announce: 
			((GLMContextChanged new) 
				presentation: self; 
				property: aPortEvent portName; 
				value: aPortEvent value; 
				oldValue: aPortEvent oldValue; 
				yourself)! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane 
	 
	^pane 
		ifNil: 
			[pane := (GLMPane new) 
				addPresentation: self; 
				yourself]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane: aPane 
	 
	pane := aPane! !

!GLMPresentation methodsFor: 'copying' stamp: ' 25/2/09 23:38'!
postCopy 
	 
	super postCopy! !

!GLMPresentation methodsFor: 'rendering' stamp: ' 25/2/09 23:38'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderPresentation: self! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 25/2/09 23:38'!
selection 
	 
	^(self pane port: #selection) value! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 25/2/09 23:38'!
selection: anObject 
	 
	(self pane port: #selection) value: anObject! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
title 
	 
	^title! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
title: aString 
	 
	title := aString! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
transformation 
	 
	^transformation ifNil: [transformation := #yourself]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
transformation: aBlock 
	 
	transformation := aBlock! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
useExplicitNotNil 
	 
	implicitNotNil := false! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
useImplicitNotNil 
	 
	implicitNotNil := true! !

!GLMPresentation methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
usesExplicitNotNil 
	 
	^self usesImplicitNotNil not! !

!GLMPresentation methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
usesImplicitNotNil 
	 
	^implicitNotNil ifNil: [implicitNotNil := true]! !

!GLMPresentation methodsFor: 'announcements' stamp: ' 25/2/09 23:38'!
whenContextChanged: aBlock 
	 
	^self when: GLMContextChanged do: aBlock! !

OrderedCollection variableSubclass: #GLMMultiValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

Announcement subclass: #GLMContextChanged
	instanceVariableNames: 'presentation property value oldValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
oldValue 
	 
	^oldValue! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
oldValue: anObject 
	 
	oldValue := anObject! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
presentation 
	 
	^presentation! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
presentation: aPresentation 
	 
	presentation := aPresentation! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
property 
	 
	^property! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
property: aSymbol 
	 
	property := aSymbol! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value 
	 
	^value! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value: anObject 
	 
	value := anObject! !

Announcement subclass: #GLMMatchingPresentationsChanged
	instanceVariableNames: 'pane oldMatchingPresentations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMMatchingPresentationsChanged methodsFor: 'accessing-convenience' stamp: ' 25/2/09 23:38'!
matchingPresentations 
	"The presentations that match now." 
	 
	^self pane matchingPresentations! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
oldMatchingPresentations 
	"The presentations that matched before this announcement." 
	 
	^oldMatchingPresentations! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
oldMatchingPresentations: aCollection 
	"The presentations that matched before this announcement." 
	 
	oldMatchingPresentations := aCollection! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane 
	"The pane on which the matching presentations changed." 
	 
	^pane! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane: aPane 
	"The pane on which the matching presentations changed." 
	 
	pane := aPane! !

Announcement subclass: #GLMPresentationsChanged
	instanceVariableNames: 'pane oldPresentations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
oldPresentations 
	"The presentations that were present on the pane before the change." 
	 
	^oldPresentations! !

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
oldPresentations: aCollection 
	"The presentations that were present on the pane before the change." 
	 
	oldPresentations := aCollection! !

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane 
	"The pane on which the presentations changed." 
	 
	^pane! !

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane: aPane 
	"The pane on which the presentations changed." 
	 
	pane := aPane! !

!GLMPresentationsChanged methodsFor: 'accessing-convenience' stamp: ' 25/2/09 23:38'!
presentations 
	"The presentationt that are currently present on the pane." 
	 
	^self pane presentations! !

Object subclass: #GLMAction
	instanceVariableNames: 'action title shortcut position category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMAction commentStamp: '<historical>' prior: 0!
Actions are elements of behavior that are executed upon a keyboard shortcut or other event.

Instances of Action are stored and maintained by Presentations. The exact representation is determined by the renderer, but actions can define a keyboard shortcut that should trigger the action or a title, category and position to be able to use the action as a context menu item.!

!GLMAction methodsFor: 'public interface' stamp: ' 25/2/09 23:38'!
actOn: aPresentation 
	 
	^self action glamourValueWithArgs: (Array with: aPresentation)! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
action 
	"The code that should be executed when this action is triggered." 
	 
	^action! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
action: aBlock 
	"The code that should be executed when this action is triggered. 
 
	The block can take optional arguments, the first will always be the 
	presentation on which this action was triggered." 
	 
	action := aBlock! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
category 
	"The name of the category that should be used when this action is displayed in a context menu." 
	 
	^category! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
category: aString 
	"The name of the category that should be used when this action is displayed in a context menu." 
	 
	category := aString! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
position 
	"The relative position within a context menu." 
	 
	^position! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
position: anInteger 
	"The relative position within a context menu." 
	 
	position := anInteger! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
shortcut 
	"Shortcut character that this action should be triggered with when the focus rests on the corresponding presentation. 
	Modifiers are platform specific an can not be defined." 
	 
	^shortcut! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
shortcut: aCharacter 
	"Shortcut character that this action should be triggered with when the focus rests on the corresponding presentation. 
	Modifiers are platform specific an can not be defined." 
	 
	shortcut := aCharacter! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
title 
	"Title that this action should use in a context menu." 
	 
	^title! !

!GLMAction methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
title: anObject 
	"Title that this action should use in a context menu." 
	 
	title := anObject! !

Object subclass: #GLMBundleOrigin
	instanceVariableNames: 'port active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBundleOrigin commentStamp: '<historical>' prior: 0!
Used by BundleTransmission to annotate its originating ports whether they are active or passive.

When a BundleTransmission consideres a port as active, the browser will trigger it when the corresponding port changes.!

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
beActive 
	 
	active := true! !

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
bePassive 
	 
	active := false! !

!GLMBundleOrigin methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
isActive 
	 
	^active ifNil: [active := true]! !

!GLMBundleOrigin methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
isPassive 
	 
	^self isActive not! !

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
port 
	 
	^port! !

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
port: aPort 
	 
	port := aPort! !

!GLMBundleOrigin methodsFor: 'accessing-convenience' stamp: ' 25/2/09 23:38'!
value 
	 
	^self port value! !

Object subclass: #GLMPort
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMPort subclass: #GLMBoundPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBoundPort methodsFor: 'comparing' stamp: ' 25/2/09 23:38'!
= anObject 
	"Compare this port with another for equality. 
 
	This is used to compare ParentPorts with PanePorts where the earlier is a proxy for the latter." 
	 
	^((anObject isKindOf: GLMBoundPort) and: [self pane = anObject pane]) 
		and: [self name = anObject name]! !

!GLMBoundPort methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
hasPane 
	 
	^self pane notNil! !

!GLMBoundPort methodsFor: 'comparing' stamp: ' 25/2/09 23:38'!
hash 
	"Ports which are equal should return hash. 
 
	Since equality is used only for matching port proxies (ParentPort) with 
	their actual port, the hash function is overridden only in ParentPort." 
	 
	^super hash! !

!GLMBoundPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane 
	 
	self subclassResponsibility! !

GLMBoundPort subclass: #GLMPanePort
	instanceVariableNames: 'pane value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPanePort commentStamp: '<historical>' prior: 0!
A port that belongs to a pane.

Bound ports have a few special characteristics in comparison to their superclass. For one, they don't just assign a value to themselves using #value: but rather generate a transmission that set the value so that the pane can handle the transmission and forward it to other ports if necessary, depending on the policy of the containing browser.!

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane 
	 
	^pane! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane: aPane 
	 
	pane := aPane! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
receive: aTransmission 
	 
	| oldValue | 
	oldValue := self value. 
	self pane 
		notingPresentationChangeDo: 
			[value := aTransmission value. 
			self pane 
				portEvent: 
					((GLMPortEvent new) 
						port: self; 
						transmission: aTransmission; 
						oldValue: oldValue; 
						yourself)]! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value 
	 
	^value! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value: anObject 
	 
	(GLMSimpleTransmission new) 
		origin: (GLMSimplePort new value: anObject); 
		destination: self; 
		transmit! !

GLMBoundPort subclass: #GLMParentPort
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMParentPort methodsFor: 'comparing' stamp: ' 25/2/09 23:38'!
hash 
	 
	^self port hash! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
pane 
	 
	^self presentation pane! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
port 
	 
	^self pane port: self name! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
presentation 
	 
	^presentation! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
presentation: aPresentation 
	 
	presentation := aPresentation! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
receive: aTransmission 
	 
	self port receive: aTransmission! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value 
	 
	^self port value! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value: anObject 
	 
	self port value: anObject! !

!GLMPort methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
hasPane 
	 
	^false! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
name 
	 
	^name! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
name: aSymbol 
	 
	name := aSymbol! !

!GLMPort methodsFor: 'printing' stamp: ' 25/2/09 23:38'!
printOn: aStream 
	 
	aStream 
		nextPutAll: 'Port (name->'; 
		nextPutAll: self name printString; 
		nextPutAll: ' value->'; 
		nextPutAll: self value printString; 
		nextPut: $)! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
receive: aTransmission 
	 
	self subclassResponsibility! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value 
	 
	self subclassResponsibility! !

!GLMPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value: anObject 
	 
	self subclassResponsibility! !

GLMPort subclass: #GLMSimplePort
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMSimplePort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
receive: aTransmission 
	 
	self value: aTransmission value! !

!GLMSimplePort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value 
	 
	^value! !

!GLMSimplePort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
value: anObject 
	 
	value := anObject! !

Object subclass: #GLMPortEvent
	instanceVariableNames: 'port transmission oldValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPortEvent methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
hasChanged 
	"Answer whether the port value changed due to the event." 
	 
	^self value ~= self oldValue! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
oldValue 
	 
	^oldValue! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
oldValue: anObject 
	 
	oldValue := anObject! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 25/2/09 23:38'!
pane 
	 
	^self port pane! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
port 
	 
	^port! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
port: aPort 
	 
	port := aPort! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 25/2/09 23:38'!
portName 
	 
	^self port name! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
transmission 
	 
	^transmission! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
transmission: aTransmission 
	 
	transmission := aTransmission! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 25/2/09 23:38'!
value 
	 
	^self port value! !

Object subclass: #GLMPublishedPort
	instanceVariableNames: 'outerPortName innerPort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPublishedPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
innerPort 
	 
	^innerPort! !

!GLMPublishedPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
innerPort: aPort 
	 
	innerPort := aPort! !

!GLMPublishedPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
outerPortName 
	 
	^outerPortName! !

!GLMPublishedPort methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
outerPortName: aSymbol 
	 
	outerPortName := aSymbol! !

Object subclass: #GLMRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 23:38'!
doOpen: aUI 
	 
	^self subclassResponsibility! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 23:38'!
open: aRenderable 
	 
	^self doOpen: (self render: aRenderable)! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 23:38'!
render: aRenderable 
	 
	^aRenderable renderGlamorouslyOn: self! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 23:38'!
renderPane: aPane 
	 
	^nil! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 25/2/09 23:38'!
renderPresentation: aPresentation 
	 
	^nil! !

Object subclass: #GLMTransmission
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMTransmission subclass: #GLMBundleTransmission
	instanceVariableNames: 'presentations destination origins'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
activeOrigins 
	 
	^(self bundleOrigins select: [:each | each isActive]) 
		collect: [:each | each port]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addActiveOrigin: aPort 
	 
	self bundleOrigins 
		add: 
			((GLMBundleOrigin new) 
				port: aPort; 
				beActive; 
				yourself)! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
addPassiveOrigin: aPort 
	 
	self bundleOrigins 
		add: 
			((GLMBundleOrigin new) 
				port: aPort; 
				bePassive; 
				yourself)! !

!GLMBundleTransmission methodsFor: 'accessing-convenience' stamp: ' 25/2/09 23:38'!
addPresentation: aPresentation 
	 
	self presentations addLast: aPresentation! !

!GLMBundleTransmission methodsFor: 'accessing-convenience' stamp: ' 25/2/09 23:38'!
addPresentations: aCollection 
	 
	aCollection do: [:each | self addPresentation: each]! !

!GLMBundleTransmission methodsFor: 'private accessing' stamp: ' 25/2/09 23:38'!
bundleOrigins 
	 
	^origins ifNil: [origins := OrderedCollection new]! !

!GLMBundleTransmission methodsFor: 'private' stamp: ' 25/2/09 23:38'!
clearOrigins 
	 
	origins := nil! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
destination 
	 
	^destination! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
destination: aPort 
	 
	destination := aPort! !

!GLMBundleTransmission methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
originatesAt: aPort 
	 
	^self activeOrigins includes: aPort! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
origins 
	 
	^self bundleOrigins collect: [:each | each port]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
passiveOrigins 
	 
	^(self bundleOrigins select: [:each | each isPassive]) 
		collect: [:each | each port]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
presentations 
	 
	^presentations ifNil: [presentations := OrderedCollection new]! !

!GLMBundleTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 23:38'!
transmit 
	 
	self destination hasPane 
		ifTrue: 
			[self destination pane clear. 
			self destination pane addPresentations: self presentations]. 
	self destination receive: self! !

!GLMBundleTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 23:38'!
value 
	 
	^self origins size = 1 
		ifTrue: [self origins first value] 
		ifFalse: 
			[GLMMultiValue withAll: (self origins collect: [:each | each value])]! !

GLMTransmission subclass: #GLMSimpleTransmission
	instanceVariableNames: 'origin destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
destination 
	 
	^destination! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
destination: aPort 
	 
	destination := aPort! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
origin 
	 
	^origin! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 25/2/09 23:38'!
origin: aPort 
	 
	origin := aPort! !

!GLMSimpleTransmission methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
originatesAt: aPort 
	 
	^self origin = aPort! !

!GLMSimpleTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 23:38'!
transmit 
	 
	self destination receive: self! !

!GLMSimpleTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 23:38'!
value 
	 
	^self origin value! !

!GLMTransmission methodsFor: 'testing' stamp: ' 25/2/09 23:38'!
originatesAt: aPort 
	 
	^false! !

!GLMTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 23:38'!
transmit 
	 
	self subclassResponsibility! !

!GLMTransmission methodsFor: 'transmitting' stamp: ' 25/2/09 23:38'!
value 
	 
	self subclassResponsibility! !
